// Mandelbrot.c
//
// Using integer math, generating ASCII output

#include <stdio.h>

void main( void ) {

   long boundL      = -560;  // -560  (x size 800, 80 steps)
   long boundR      =  240;  //  240
   long boundT      =  220;  //  220
   long boundB      = -240;  // -240  (y size 460, 23 steps)
   long x_iter      =   10;  //  10
   long y_iter      =   20;  //  20   (step ratio 2:1, y:x)
   long max         =   20;  //  20
   long n,zxx,zyy,zx,zy,cx,cy;
   char p;

   for( cy=boundT; cy > boundB; cy -= y_iter ) {
      putchar( '\n' );
      for( cx=boundL; cx < boundR; cx += x_iter ) {
         n  = 0;
         zy = 0;
         zx = 0;
         p  = ' ';
         while( n < max ) {
            zxx = zx * zx / 200;
            zyy = zy * zy / 200;
            if( (zxx + zyy) > 800 ) {
               if( n > 9 ) 
                  p = '0';
               else
                  p = n + 48;
               n = max;
            }
            zy = zx * zy / 100 + cy;
            zx = zxx - zyy + cx;
            n++;
         }
         putchar( p );
      }
   }
   return;
}

